//****************************************************************************
//	aisa04s.pas
//
//	aISA-P04W/H
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/01
//
//  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa04s;

interface

uses
  Windows, Messages, SysUtils, Forms, aisa04w;

const
	szTitle = 'Sample';
	szP04W = 'aISA-P04W';
	szP04H = 'aISA-P04H';

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  strbuf:  String;
	strName: String;
	dwDLLVer, dwDrvVer: DWord;
	bResult:  Boolean;				// 
	wLogSlot: Word; 					// foCXi[
	OutValue:	Byte;						// o͒l
{$IFDEF 0}  // RpCLZ܂B
	InValue:	Byte;						// ͒l
{$ENDIF}
	ri:       TAISA04RESOURCE;	// \[X
begin
//---------------------------------------------------------------------------
	// aisa04.dll ̎gp錾
	if Aisa04wDllOpen() = False then
	begin
		ErrorMessage(AISA04_SLOT_AUTO);
		Exit;			// aisa04.dll ̃[hɎs܂
  end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aISA-P04W/H DLL,Driver̃o[Wԍ擾
	if Aisa04wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(AISA04_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Drv Version: %08xH',
                     [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-P04W/H̎gp錾
	wLogSlot := AISA04_SLOT_AUTO;				// gp̃foCXT܂B
	bResult := Aisa04wCreate(wLogSlot);	// ꍇA̎̃foCXi[܂B

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA04_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-P04W/H Created'#10#10 +
                   'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// \[X擾
	if Aisa04wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

//---------------------------------------------------------------------------
	// foCX̎
	if ri.dwIOPortLength[1] = AISA04_MAX_PORT_W then
		strName := szP04W		// aISA-P04W
	else
		strName := szP04H;	// aISA-P04H

	strbuf := Format('Board Name: %s'#10 +
    				 'NumPorts: %2d'#10 +
    				 'IO Address: %04xH-%04xH',
                     [strName, ri.dwIOPortLength[1],
                      ri.dwIOPortBase[1],
	                    ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// 82C55̏
	// S߰ĂӰ0̏o͂ŏ܂BiHoגlj

	// PPI1 ̓w
	if Aisa04wOutPort(wLogSlot, AISA04_PPI1_CTL, $80) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('PPI1܂B');

	// PPI2 ̓w
	if Aisa04wOutPort(wLogSlot, AISA04_PPI2_CTL, $80) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('PPI2܂B');

	if ri.dwIOPortLength[1] = AISA04_MAX_PORT_W then		// aISA-04Wp
	begin
		// PPI3 ̓w
		if Aisa04wOutPort(wLogSlot, AISA04_PPI3_CTL, $80) = False then
		begin
			ErrorMessage(wLogSlot);
			Exit;
		end;

		ResultMessage('PPI3܂B');

		// PPI4 ̓w
		if Aisa04wOutPort(wLogSlot, AISA04_PPI4_CTL, $80) = False then
		begin
			ErrorMessage(wLogSlot);
			Exit;
		end;

		ResultMessage('PPI4܂B');
	end;

//---------------------------------------------------------------------------
	// Cӂ߰Ă
	// Ӱ0̏o͂ŏ܂̂ŁA͂ȂĂ܂B
{$IFDEF 0}		  // RpCLZ܂B
	if Aisa04wInPort(wLogSlot, AISA04_PPI1_A, InValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('PPI1-Af[^'#10 +
					         'PPI1-A InPort Data: %02xH',
					 				 [InValue]);

	ResultMessage(strbuf);
{$ENDIF}

//---------------------------------------------------------------------------
	// Cӂ߰Ă֏o
	OutValue := Byte($FF);			// o͒l FFHw
	if Aisa04wOutPort(wLogSlot, AISA04_PPI1_B, OutValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('OutPort s܂B');

//---------------------------------------------------------------------------
	// aISA-P04W/H̎gpJ
	if Aisa04wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-P04W/H Closed');

	// aisa04.dll ̎gpJ
	if Aisa04wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa04.dll ̃A[hɎs܂B
  end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa04wGetLastError(wLogSlot);

	case dwRes of
		AISA04_ERR_SYSTEM:
			strbuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);

		AISA04_ERR_WRAPDLL:
    	strbuf := 'DLL Load error';
  else
		strbuf := Format('aISA-P04W/H error'#10#10'Error code: %08xH',[dwRes]);
  end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
