//****************************************************************************
//	aisa04w.pas
//
//	aISA-P04W/H
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/01
//
//****************************************************************************

unit aisa04w;

interface

uses
	Windows;

const
	{ װ }
	AISA04_SUCCESS							= 0;				{ ُȂ }
	AISA04_ERR_SYSTEM						= 1;				{ GetLastError sĂ }
	AISA04_ERR_NO_DEVICE				= 2;				{ gۯĂȂ }
	AISA04_ERR_IN_USE						= 3;				{ w肳ꂽۯĂ͎gp }
	AISA04_ERR_INVALID_SLOT			= 4;				{ sȽۯĔԍw }
	AISA04_ERR_INVALID_PORT			= 6;				{ sȃ|[gv }
	AISA04_ERR_INVALID_ARGUMENT	= 7;				{ sȈv }

	{ ߰Ė }
	AISA04_PPI1_A		            =	0;			  { PPI1 Port A }
	AISA04_PPI1_B		            = 1;			  { PPI1 Port B }
	AISA04_PPI1_C		            = 2;			  { PPI1 Port C }
	AISA04_PPI1_CTL	            = 3;			  { PPI1 Control Port }

	AISA04_PPI2_A			          = 4;			  { PPI2 Port A }
	AISA04_PPI2_B				        = 5;			  { PPI2 Port B }
	AISA04_PPI2_C			          = 6;			  { PPI2 Port C }
	AISA04_PPI2_CTL				      = 7;			  { PPI2 Control Port }

	{ aISA-04W p }
	AISA04_PPI3_A				        = 8;			  { PPI3 Port A }
	AISA04_PPI3_B				        = 9;			  { PPI3 Port B }
	AISA04_PPI3_C				        = 10;			  { PPI3 Port C }
	AISA04_PPI3_CTL				      = 11;			  { PPI3 Control Port }

	AISA04_PPI4_A				        = 12;			  { PPI4 Port A }
	AISA04_PPI4_B				        = 13;			  { PPI4 Port B }
	AISA04_PPI4_C				        = 14;			  { PPI4 Port C }
	AISA04_PPI4_CTL				      = 15;			  { PPI4 Control Port }

{ ̑ }

const
	AISA04_MAX_SLOTS	= 16;	{ Maximum number of slots }

const
	AISA04_MAX_PORT_W = 16;	{ aISA-P04W̃|[g }
	AISA04_MAX_PORT_H = 8;	{ aISA-P04H̃|[g }

const
	AISA04_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA04_DLL_NAME = 'aisa04.dll';		{ DLL }

function Aisa04wDllOpen: Boolean;		{ DLL [h }
function Aisa04wDllClose: Boolean;	{ DLL A[h }


const
	AISA04_SLOT_AUTO = $ffff;

{ aISA-P04W/H DLL,Driver̃o[Wԍ擾 }
function Aisa04wGetVersion(var pdwDll: DWord; var pdwDrv: DWord): Boolean;


{ CӂaISA-P04W/H̎gp錾 }
function Aisa04wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-P04W/H̎gpJ }
function Aisa04wClose(wLogSlot: Word): Boolean;


const
{ ؿ\̗p }
		AISA04_MAX_MEM	=	 9;
		AISA04_MAX_IO		= 20;
		AISA04_MAX_IRQ	=	 7;
		AISA04_MAX_DMA	=	 7;

type
		TAISA04RESOURCE = record
				dwNumMemWindows:DWord;																	{ Not used }
				dwMemBase:			array [1 .. AISA04_MAX_MEM] of DWord;		{ Not used }
				dwMemLength:		array [1 .. AISA04_MAX_MEM] of DWord;		{ Not used }
				dwMemAttrib:		array [1 .. AISA04_MAX_MEM] of DWord;		{ Not used }
				dwNumIOPorts:		DWord;																	{ Num IO ports }
				dwIOPortBase:		array [1 .. AISA04_MAX_IO] of DWord;		{ I/O port base }
				dwIOPortLength: array [1 .. AISA04_MAX_IO] of DWord;		{ I/O port length }
				dwNumIRQs:			DWord;																	{ Num IRQ info }
				dwIRQRegisters: array [1 .. AISA04_MAX_IRQ] of DWord;		{ IRQ list }
				dwIRQAttrib:		array [1 .. AISA04_MAX_IRQ] of DWord;		{ IRQ Attrib list }
				dwNumDMAs:			DWord;																	{ Not used }
				dwDMALst:				array [1 .. AISA04_MAX_DMA] of DWord;		{ Not used }
				dwDMAAttrib:		array [1 .. AISA04_MAX_DMA] of DWord;		{ Not used }
				dwReserved1:		array [1 .. 3] of DWord;								{ Not used }
		end;

PAISA04RESOURCE = ^TAISA04RESOURCE;

{ \[X擾 }
function Aisa04wGetResource(wLogSlot: Word; pres: PAISA04RESOURCE): Boolean;


{ Cӂ̃|[gf[^ }
function Aisa04wInPort(wLogSlot: Word; dwPort: DWord; var pbValue: Byte): Boolean;
{ Cӂ̃|[gփf[^o }
function Aisa04wOutPort(wLogSlot: Word; dwPort: DWord; bValue: Byte): Boolean;


{ aISA-P04W/H̃G[R[h }
function Aisa04wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa04GetVersion = function(var pdwDll: DWord; var pdwDrv: DWord): Bool; stdcall;
	TAisa04Create = function(var pwLogSlot: Word): Bool; stdcall;
	TAisa04Close = function(wLogSlot:	Word): Bool; stdcall;
	TAisa04GetResource = function(wLogSlot: Word; pres: PAISA04RESOURCE):	Bool; stdcall;
	TAisa04InPort = function(wLogSlot: Word; dwLogPort: DWord; var pbValue: Byte): Bool; stdcall;
	TAisa04OutPort = function(wLogSlot: Word; dwLogPort: DWord; bValue: Byte): Bool; stdcall;
	TAisa04GetLastError = function(wLogSlot: Word): DWord; stdcall;

function Aisa04wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa04GetVersion: TAisa04GetVersion;
	pAisa04Create: TAisa04Create;
	pAisa04Close: TAisa04Close;
	pAisa04GetResource: TAisa04GetResource;
	pAisa04InPort: TAisa04InPort;
	pAisa04OutPort: TAisa04OutPort;
	pAisa04GetLastError: TAisa04GetLastError;


//****************************************************************************
// 		aisa04.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa04wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA04_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa04wGetDllExportFunc = False then
  begin
		Aisa04wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		aisa04.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa04wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// 		aISA-P04W/H DLL,Driver̃o[Wԍ擾
// 		pdwDll DLLo[Wԍi[
//				pdwDrv Drivero[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa04wGetVersion(var pdwDll: DWord; var pdwDrv: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa04GetVersion(pdwDll, pdwDrv);
end;

//****************************************************************************
// 		aISA-P04W/H̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[AhX
// ߂l  True
//				s False
//****************************************************************************
function Aisa04wCreate(var pwLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa04Create(pwLogSlot);
end;

//****************************************************************************
// 		aISA-P04W/H̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Aisa04wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa04Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pres     \[Xi[\̂̃AhX
// ߂l  True
//				s False
//****************************************************************************
function Aisa04wGetResource(wLogSlot: Word; pres: PAISA04RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa04GetResource(wLogSlot, pres);
end;

//****************************************************************************
// 		Cӂ̃|[gf[^
// 		wLogSlot ͂foCX
//				dwPort	 ͂|[g
//				pbValue  ̓f[^i[
// ߂l  True
//				s False
//****************************************************************************
function Aisa04wInPort(wLogSlot: Word; dwPort: DWord; var pbValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa04InPort(wLogSlot, dwPort, pbValue);
end;

//****************************************************************************
// 		Cӂ̃|[gփf[^o
// 		wLogSlot o͂foCX
//				dwPort	 o͂|[g
//				bValue   o͂f[^
// ߂l  True
//				s False
//****************************************************************************
function Aisa04wOutPort(wLogSlot: Word; dwPort: DWord; bValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa04OutPort(wLogSlot, dwPort, bValue);
end;

//****************************************************************************
// 		aISA-P04W/H̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Aisa04wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA04_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa04GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 	  DLLGNX|[g֐AhX̎擾
// 	  
// ߂l  True
//		  	s False
//---------------------------------------------------------------------------
function Aisa04wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa04GetVersion ̃AhX擾
	pAisa04GetVersion := GetProcAddress(hDLL, 'Aisa04GetVersion');
	if @pAisa04GetVersion = nil then Exit;

	// Aisa04Create ̃AhX擾
	pAisa04Create := GetProcAddress(hDLL, 'Aisa04Create');
	if @pAisa04Create = nil then Exit;

	// Aisa04Close ̃AhX擾
	pAisa04Close := GetProcAddress(hDLL, 'Aisa04Close');
	if @pAisa04Close = nil then Exit;

	// Aisa04GetResource ̃AhX擾
	pAisa04GetResource := GetProcAddress(hDLL, 'Aisa04GetResource');
	if @pAisa04GetResource = nil then Exit;

	// Aisa04InPort ̃AhX擾
	pAisa04InPort := GetProcAddress(hDLL, 'Aisa04InPort');
	if @pAisa04InPort = nil then Exit;

	// Aisa04OutPort ̃AhX擾
	pAisa04OutPort := GetProcAddress(hDLL, 'Aisa04OutPort');
	if @pAisa04OutPort = nil then Exit;

	// Aisa04GetLastError ̃AhX擾
	pAisa04GetLastError := GetProcAddress(hDLL, 'Aisa04GetLastError');
	if @pAisa04GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

