/******************************************************************************/
/*	aisa04s.c																  */
/*																			  */
/*	aISA-P04W/H															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1998/03/05															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>

#include "aisa04w.h"


const TCHAR szTitle[] = _T("Sample");
const TCHAR szP04W[] = _T("aISA-P04W");
const TCHAR szP04H[] = _T("aISA-P04H");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	TCHAR szName[50];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	BYTE  OutValue;					// o͒l
#if 0	// RpCLZ܂B
	BYTE InValue;				// ͒l
#endif
	AISA04RESOURCE ri;				// \[X

/*---------------------------------------------------------------------------*/
	// aisa04.dll ̎gp錾
	if (Aisa04wDllOpen() == FALSE)
	{
		ErrorMessage(AISA04_SLOT_AUTO);
		return 1;			// aisa04.dll ̃[hɎs܂
	}

/*---------------------------------------------------------------------------*/
	// o[Wԍ\
	// aISA-P04W/H DLL,Driver̃o[Wԍ擾
	if (Aisa04wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE)
	{
		ErrorMessage(AISA04_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"),
					dwDLLVer,
					dwDrvVer);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-P04W/H̎gp錾
	wLogSlot = AISA04_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Aisa04wCreate(&wLogSlot);	// ꍇA̎̃foCXi[܂B

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(AISA04_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("aISA-P04W/H Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// \[X擾
	if (Aisa04wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

/*---------------------------------------------------------------------------*/
	// foCX̎
	if (ri.dwIOPortLength[0] == AISA04_MAX_PORT_W)
		lstrcpy(szName, szP04W);	// aISA-P04W
	else
		lstrcpy(szName, szP04H);	// aISA-P04H

	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh"),
					szName,
					ri.dwIOPortLength[0],
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// 82C55̏
	// S߰ĂӰ0̏o͂ŏ܂BiHoגlj

	// PPI1 ̓w
	if (Aisa04wOutPort(wLogSlot, AISA04_PPI1_CTL, 0x80) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage("PPI1܂B");

	// PPI2 ̓w
	if (Aisa04wOutPort(wLogSlot, AISA04_PPI2_CTL, 0x80) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage("PPI2܂B");

	if (ri.dwIOPortLength[0] == AISA04_MAX_PORT_W)		// aISA-04Wp
	{
		// PPI3 ̓w
		if (Aisa04wOutPort(wLogSlot, AISA04_PPI3_CTL, 0x80) == FALSE)
		{
			ErrorMessage(wLogSlot);
			return 1;
		}

		ResultMessage("PPI3܂B");

		// PPI4 ̓w
		if (Aisa04wOutPort(wLogSlot, AISA04_PPI4_CTL, 0x80) == FALSE)
		{
			ErrorMessage(wLogSlot);
			return 1;
		}

		ResultMessage("PPI4܂B");
	}

/*---------------------------------------------------------------------------*/
	// Cӂ߰Ă
	// Ӱ0̏o͂ŏ܂̂ŁA͂ȂĂ܂B
#if 0	// RpCLZ܂B
	if (Aisa04wInPort(wLogSlot, AISA04_PPI1_A, &InValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("PPI1-Af[^\n")
					_T("PPI1-A InPort Data: %02xh"),
					 InValue);

	ResultMessage(szbuf);
#endif

/*---------------------------------------------------------------------------*/
	// Cӂ߰Ă֏o
	OutValue = 0xFF;			// o͒l FFHw
	if (Aisa04wOutPort(wLogSlot, AISA04_PPI1_B, OutValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage("OutPort s܂B");

/*---------------------------------------------------------------------------*/
	// aISA-P04W/H̎gpJ
	if (Aisa04wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aISA-P04W/H Closed"));

/*---------------------------------------------------------------------------*/
	// aisa04.dll ̎gpJ
	if (Aisa04wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// aisa04.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa04wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case AISA04_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"),
							GetLastError());
			break;

		case AISA04_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-P04W/H error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
